@ECHO OFF
:: ------------------------------Read me--------------------------------------
:: Revision : 2.1.6
::     Date : 2016.01.23
::  Created : 2015.11.09
::  Purpose : Make media thumbnail
::    usege : Make_Thumbnail [media file name]
:: ---------------------------------------------------------------------------

SET infile=%1
SET split=30
SET layout=5
SET size=214x120

SET fontfile=D\:/ffmpeg/LED_font.ttf
SET FFmpeg_path=D:\ffmpeg\
:: --------------------------------
:: get media info
:: --------------------------------
SET PATH=%PATH%;%FFmpeg_path%
IF NOT defined infile ECHO input media file.&PAUSE>NUL&exit
SET fontfile_dosName=%fontfile:\=%
IF NOT EXIST %fontfile_dosName% ECHO check font file.&PAUSE>NUL&exit

title Make thumbnail
setlocal enabledelayedexpansion
rem mode con cols=82 lines=14 & color 08

rem call :initColorPrint

SET isechoc=true
echoc 01 "test">nul
if "%ERRORLEVEL%" NEQ "0" (SET isechoc=false& echo. & call :initColorPrint)

SET begin_time=%date:~0,10% %time:~0,11%

SET infile=%infile:"=%
FOR /F "delims=x tokens=1,2" %%i IN ("%size%") DO SET _w=%%i&SET _h=%%j
SET tmpfile=%TMP%_t1_%RANDOM%
SET tmpImgDir=%TMP%\imgs_%RANDOM%\
IF EXIST %tmpImgDir% rd %tmpImgDir% /S /Q
md %tmpImgDir%
IF EXIST %tmpfile% del %tmpfile%

%FFmpeg_path%ffprobe -v fatal -show_error -show_format -show_streams -i "%infile%">%tmpfile%

if "%ERRORLEVEL%" NEQ "0" (
    ECHO ERROR : isn't media file
	IF EXIST %tmpImgDir% rd %tmpImgDir% /S /Q
	pause>nul
	GOTO :eof )

SET isVideo=0

FOR /F "usebackq tokens=1,2 delims==" %%i IN (%tmpfile%) DO (
	IF /I "%%i" == "codec_type" IF /I "%%j" == "video" SET isVideo=1
    IF /I "%%i" == "codec_type" IF /I "%%j" == "audio" SET isVideo=2
	IF /I "%%i" == "[FORMAT]" SET isVideo=3
	
	IF "!isVideo!" == "1" (
    IF /I "%%i" == "coded_width"       SET coded_width=%%j
	IF /I "%%i" == "coded_height"      SET coded_height=%%j
    IF /I "%%i" == "duration"          SET duration=%%j
    IF /I "%%i" == "nb_frames"         SET nb_frames=%%j
    IF /I "%%i" == "avg_frame_rate"    SET avg_frame_rate=%%j
	)
	IF "!isVideo!" == "3" (
		IF "!duration!" == "N/A" (
			IF /I "%%i" == "duration"  SET duration=%%j
		)
	)	
)
IF EXIST %TMP%_t1 del %tmpfile%

IF "%duration%" == "N/A" (
    ECHO ERROR : duration N/A.
	IF EXIST %tmpImgDir% rd %tmpImgDir% /S /Q
	pause>nul
    GOTO :eof
)

FOR /F "delims=. tokens=1,2" %%i IN ("%duration%") DO SET _num=%%i&SET _dot=%%j000
SET duration_ms=%_num%%_dot:~0,3%

IF "%duration%" == "" (
    ECHO ERROR : duration empty.
	IF EXIST %tmpImgDir% rd %tmpImgDir% /S /Q
	pause>nul
    GOTO :eof
)

SET /a sec=%_num%
SET /a tmin=%sec%/60
SET /a tsec=%sec%-%tmin%*60
SET /a thour=%tmin%/60
SET /a tmin=%tmin%-%thour%*60
IF %thour% LEQ 9 (SET thour=0%thour%)
IF %tmin%  LEQ 9 (SET tmin=0%tmin%)
IF %tsec%  LEQ 9 (SET tsec=0%tsec%)
SET duration_str=%thour%:%tmin%:%tsec%.%_dot:~0,3%

SET /a avg_frame_rate_tmp=1000*%avg_frame_rate%
SET avg_frame_rate_str=%avg_frame_rate_tmp:~0,-3%.%avg_frame_rate_tmp:~-3%

SET /p a=_<nul

rem call :colorPrint 07 "media info"
rem echoc 07 "media info"
if "%isechoc%"=="true" (echoc 03 "media info") else (call :colorPrint 03 "media info")

ECHO ____________________________________________________________________
SET /p a= filename   =<nul 

rem call :colorPrint 03 "%infile%" /n
rem echoc 07 "%infile%" & ECHO.
if "%isechoc%"=="true" (echoc 02 "%infile%" & ECHO.) else (call :colorPrint 02 "%infile%" /n)

SET /p a= resolution =<nul
SET resolution= %coded_width% x %coded_height%

rem call :colorPrint 03 "%resolution%" /n
rem echoc 07 "%resolution%" & ECHO.
if "%isechoc%"=="true" (echoc 02 "%resolution%" & ECHO.) else (call :colorPrint 02 "%resolution%" /n)

SET /p a= duration   = %duration_ms%ms = <nul

rem call :colorPrint 03 "%duration%"
rem echoc 07 "%duration%"
if "%isechoc%"=="true" (echoc 02 "%duration%") else (call :colorPrint 02 "%duration%")

ECHO s = %duration_str%
SET /p a= frames     = <nul

rem call :colorPrint 03 "%nb_frames%"
rem echoc 07 "%nb_frames%"
if "%isechoc%"=="true" (echoc 02 "%nb_frames%") else (call :colorPrint 02 "%nb_frames%")

ECHO f
SET /p a= frame_rate = %avg_frame_rate% = <nul

rem call :colorPrint 03 "%avg_frame_rate_str%" /n
rem echoc 07 "%avg_frame_rate_str%" & ECHO.
if "%isechoc%"=="true" (echoc 02 "%avg_frame_rate_str%" & ECHO.) else (call :colorPrint 02 "%avg_frame_rate_str%" /n)

SET /a stepms=%duration_ms%/(%split%+1)
SET /p a=_<nul

rem call :colorPrint 07 "output settings"
rem echoc 07 "output settings"
if "%isechoc%"=="true" (echoc 03 "output settings") else (call :colorPrint 03 "output settings")

ECHO _______________________________________________________________
SET /p a= split      = <nul

rem call :colorPrint 02 "%split%" /n
rem echoc 07 "%split%" & ECHO.
if "%isechoc%"=="true" (echoc 02 "%split% / %layout%" & ECHO.) else (call :colorPrint 02 "%split% / %layout%" /n)

SET /p a= step       = <nul

rem call :colorPrint 02 "%stepms%"
rem echoc 07 "%stepms%"
if "%isechoc%"=="true" (echoc 02 "%stepms%") else (call :colorPrint 02 "%stepms%")

ECHO ms
SET /p a= image size = <nul
SET image_size=%_w% x %_h%

rem call :colorPrint 02 "%image_size%" /n
rem echoc 07 "%image_size%" & ECHO.
if "%isechoc%"=="true" (echoc 02 "%image_size%" & ECHO.) else (call :colorPrint 02 "%image_size%" /n)

:: --------------------------------
:: make thumbnail images
:: --------------------------------

SET /a fontsize=%coded_height%/8
SET /a fontsize2=%fontsize%/4

SET /p a= <nul
rem FOR /L %%i IN (1,1,%split%-1) DO SET /p a=<nul
rem FOR /L %%i IN (1,1,%split%-1) DO SET len=!len! 
rem echoc 88 "%len%"

rem FOR /L %%i IN (1,1,%split%-1) DO SET len=!len! 
SET percent_max=72
FOR /L %%i IN (1,1,%percent_max%) DO SET len=!len! 
IF "!isechoc!"=="true" (echoc 88 "!len!") else ( call :colorPrint 88 "!len!" )

FOR /L %%i IN (1,1,%percent_max%) DO SET /p a=<nul

SET /a percent_bar_old=0
FOR /L %%i IN (1,1,%split%) DO (
    SET /a pos=%%i*%stepms%
	SET sec=!pos:~0,-3!
	SET dot=!pos:~-3!
	IF not defined sec SET sec=0
	
	SET /a percent=100*%%i/%split%
	SET /a percent_bar=%percent_max%*!percent!/100
	title Make thumbnail !percent!%%
	
	SET /a tmin=!sec!/60
	SET /a tsec=!sec!-!tmin!*60
	SET /a thour=!tmin!/60
	SET /a tmin=!tmin!-!thour!*60
	
	IF !thour! LEQ 9 (SET thour=0!thour!)
	IF !tmin!  LEQ 9 (SET tmin=0!tmin!)
	IF !tsec!  LEQ 9 (SET tsec=0!tsec!)

	IF %%i LSS 100 (SET tn=0%%i)
	IF %%i LSS 10  (SET tn=00%%i)
	IF %%i GEQ 100 (SET tn=%%i)

	rem SET /p a=<nul
	rem echoc 77 " "
	rem if "%isechoc%"=="true" (echoc 77 " ") else (SET /p a= <nul)
	
	SET /a percent_bar_step=!percent_bar!-!percent_bar_old!
	
	IF !percent_bar_step! GEQ 1 ( 
	SET onestepbar=
	FOR /L %%i IN (1,1,!percent_bar_step!) DO SET onestepbar=!onestepbar!
	if "%isechoc%"=="true" (echoc 77 !onestepbar!) else (SET /p a=!onestepbar!<nul) )
	rem echo !percent_bar_step!.!percent_bar!.
	
	SET /a percent_bar_old=%percent_max%*!percent!/100
	
	SET vf=-vf drawtext='fontfile=%fontfile%:x=10:y=h-%fontsize%+%fontsize2%:fontsize=%fontsize%:fontcolor=#f0f0f0:shadowcolor=#303030:shadowx=1:shadowy=1:rate=1:text=!tn!-!thour!\:!tmin!\:!tsec!.!dot!:expansion=normal:start_number=0:borderw=0:bordercolor=#303030:box=0:boxcolor=#303030@0.2'
	%FFmpeg_path%ffmpeg -v fatal -ss !sec!.!dot! -i "%infile%" -an -y -vframes 1 -s %size% !vf! "%tmpImgDir%thumbnail-!tn!.png"
)
FOR /L %%i IN (1,1,%percent_max%) DO SET /p a=<nul
SET /p a=<nul
title Make thumbnail

:: --------------------------------
:: make thumbnail
:: --------------------------------

SET allfn=
SET /a iLine=1

dir %tmpImgDir%\*.png /b/w/n/on>%tmpImgDir%_img.txt
FOR /f "eol=# delims=" %%i IN (%tmpImgDir%_img.txt) DO (
SET allfn=!allfn! -i "%%i"
SET /a iLine=!iLine!+1
)

del %tmpImgDir%_img.txt

SET /a iLine=!iLine!-1
SET /a width=!iLine!*%_w%

SET /a w=%layout%
SET /a h=!iLine!/!w!
SET /a mod=!iLine!-!h!*!w!
IF !mod! NEQ 0 (SET /a h=!h!+1)
SET /a w1=!w!*%_w%
SET /a h1=!h!*%_h%

setlocal disabledelayedexpansion

SET infile=%infile:.mp4=%
SET infile=%infile:.avi=%
SET infile=%infile:.mkv=%
SET infile=%infile:.flv=%
SET infile=%infile:"=%

rem ffmpeg -v fatal %allfn% -filter_complex concat=n=%iLine%,tile=%iLine%x1,scale=%width%x120 thumbnail-%iLine%x1.png -y
SET outFile=%infile%.thumbnail.%w%x%h%.png
SET isFullName=%infile:~1,1%
IF "%isFullName%" NEQ ":" (
	SET outFile=%cd%\%infile%.thumbnail.%w%x%h%.png
	)

pushd %tmpImgDir%
%FFmpeg_path%ffmpeg -v fatal %allfn% -filter_complex concat=n=%iLine%,tile=%w%x%h%,scale=%w1%x%h1% "%outFile%" -y
popd

IF EXIST %tmpImgDir% rd %tmpImgDir% /S /Q
SET end_time=%date:~0,10% %time%

SET /p a=_<nul

rem call :colorPrint 07 "elapsed time"
rem echoc 07 "elapsed time"
if "%isechoc%"=="true" (echoc 03 "elapsed time") else (call :colorPrint 03 "elapsed time")

ECHO __________________________________________________________________
call :Fun_CalculateTotalTime %begin_time:~11,11% %end_time:~11,11%
SET elapsed_time=[%begin_time:~11,11% - %end_time:~11,11%] = %total_time:~0,12%
SET /p a= <nul

rem call :colorPrint 80 "%elapsed_time%" /n
rem echoc 08 "[%begin_time:~11,11% - %end_time:~11,11%] = "
rem echoc 07 "%total_time:~0,12% "

if "%isechoc%"=="true" (
echoc 08 "[%begin_time:~11,11% - %end_time:~11,11%] = "
echoc 02 "%total_time:~0,12% "
) else (call :colorPrint 08 "[%begin_time:~11,11% - %end_time:~11,11%] = "
call :colorPrint 02 "%total_time:~0,12% " )

rem call :cleanupColorPrint
if "%isechoc%"=="false" (call :cleanupColorPrint)

rem echo 
rem PAUSE>NUL & GOTO :eof
echo.
echo %outFile%
exit /b

rem :ECHOC
rem SET /p a= <nul>"%~2"&findstr /v /a:%1 /R "" "%~2" nul&del "%~2"&GOTO :eof

:: ---------------------------------------------------------------------------
::  Purpose : echo with different colors in the Windows batch file
:: ---------------------------------------------------------------------------
:colorPrint Color  Str  [/n]
SET "str=%~2"
call :colorPrintVar %1 str %3
EXIT /b

:colorPrintVar  Color  StrVar  [/n]
IF not defined %~2 EXIT /b
setlocal enableDelayedExpansion
SET "str=a%DEL%!%~2:\=a%DEL%\..\%DEL%%DEL%%DEL%!"
SET "str=!str:/=a%DEL%/..\%DEL%%DEL%%DEL%!"
SET "str=!str:"=\"!"
PUSHD "%temp%"
findstr /p /A:%1 "." "!str!\..\x" nul
IF /i "%~3"=="/n" ECHO.
EXIT /b

:initColorPrint
FOR /F "tokens=1,2 delims=#" %%a in ('"prompt #$H#$E# & ECHO  on & FOR %%b in (1) do rem"') do SET "DEL=%%a"
<nul >"%temp%\x" SET /p "=%DEL%%DEL%%DEL%%DEL%%DEL%%DEL%.%DEL%"
EXIT /b

:cleanupColorPrint
del "%temp%\x"
EXIT /b
:: ---------------------------------------------------------------------------

:: ------------------------------Fun_CalculateTotalTime-----------------------
:: Revision : 1.0.3
::     Date : 2012-09-30
::  Created : 2012-05-19
::  Purpose : Calculate time
::    usege : call :Fun_CalculateTotalTime 01:02:03.400 04:03:10.510 [display]
:: results in TOTAL_TIME Environment variables
:: ------------------Calculate the total time---------------------------------
::                        012345678901
:: SET      start_pos_tmp=01:02:03.400
:: SET        end_pos_tmp=04:03:10.510
:Fun_CalculateTotalTime
SET start_pos_tmp=%1
SET end_pos_tmp=%2

IF "%start_pos_tmp:~1,1%"==":" SET "start_pos_tmp=0%start_pos_tmp%"
IF "%end_pos_tmp:~1,1%"==":" SET "end_pos_tmp=0%end_pos_tmp%"

SET hour=%start_pos_tmp:~0,2%
SET min=%start_pos_tmp:~3,2%
SET sec=%start_pos_tmp:~6,2%
SET msec=%start_pos_tmp:~9,3%

rem --------for skip 08 09---------------
IF %hour:~0,1%==0  SET hour=%hour:~1,1%
IF %min:~0,1%==0   SET min=%min:~1,1%
IF %sec:~0,1%==0   SET sec=%sec:~1,1%
IF %msec:~0,1%==0  SET msec=%msec:~1,2%
IF %msec:~0,1%==0  SET msec=%msec:~1,1%

SET /a hour=%hour%
SET /a min=%min%
SET /a sec=%sec%
SET /a msec=%msec%

SET /a start_millsec=%hour%*60*60+%min%*60+%sec%
SET /a start_millsec=%start_millsec%*1000+%msec%

SET ehour=%end_pos_tmp:~0,2%
SET emin=%end_pos_tmp:~3,2%
SET esec=%end_pos_tmp:~6,2%
SET emsec=%end_pos_tmp:~9,3%

rem --------for skip 08 09---------------
IF %ehour:~0,1%==0  SET ehour=%ehour:~1,1%
IF %emin:~0,1%==0   SET emin=%emin:~1,1%
IF %esec:~0,1%==0   SET esec=%esec:~1,1%
IF %emsec:~0,1%==0  SET emsec=%emsec:~1,2%
IF %emsec:~0,1%==0  SET emsec=%emsec:~1,1%

SET /a ehour=%ehour%
SET /a emin=%emin%
SET /a esec=%esec%
SET /a emsec=%emsec%

SET /a end_millsec=%ehour%*60*60+%emin%*60+%esec%
SET /a end_millsec=%end_millsec%*1000+%emsec%
SET /a total_time_millsec=%end_millsec%-%start_millsec%
SET /a tsec=%total_time_millsec%/1000
SET /a tmsec=%total_time_millsec%-%tsec%*1000
SET /a tmin=%tsec%/60
SET /a tsec=%tsec%-%tmin%*60
SET /a thour=%tmin%/60
SET /a tmin=%tmin%-%thour%*60

IF %thour% LEQ 9 (SET thour=0%thour%)
IF %tmin%  LEQ 9 (SET tmin=0%tmin%)
IF %tsec%  LEQ 9 (SET tsec=0%tsec%)
IF %tmsec%  LEQ 9 (SET tmsec=00%tmsec%) else (IF %tmsec%  LEQ 99 (SET tmsec=0%tmsec%))
SET total_time=%thour%:%tmin%:%tsec%.%tmsec%
IF "%3"=="display" (echo [%start_pos_tmp% - %end_pos_tmp%] = %total_time%)
EXIT /b
:: ------------------Calculate the total time---------------------------------
